#ifndef FUNCTIONS_H
#define FUNCTIONS_H

#ifndef _USE_MATH_DEFINES
#define _USE_MATH_DEFINES
#endif

#include <cmath>
#include <stdexcept>
#include <string>
#include <algorithm>

using std::runtime_error;
using std::string;
using std::abs;

double TSin(const double &x);
double TAsin(const double &x);
double TTan(const double &x);
double TAtan(const double &x);

double TCos(const double &x);
double TAcos(const double &x);

class TFPE : public runtime_error
{
private:
    string what_message;
public:
    TFPE() : runtime_error("Arc-Sine of Greater than 1")
    {
        what_message = "Arc-Sine of Greater than 1";
    }
    const char* what()
    {
        return what_message.c_str();
    }
};


#endif
